------------------------------------------------------------------
--BankGridView.lua
--Author: ingeniousclown
--v0.2

--BankGridView was designed to try and leverage the default
--UI as much as possible to create a grid view.  The result is
--somewhat hacky, but it works well.

--Main functions for the mod.
------------------------------------------------------------------

local settings = nil

local function ButtonClickHandler(button)
	if ZO_PlayerBankBackpack.isGrid then
		settings.isBankGrid = false
		BankGridView_ToggleGrid(false)
		-- d("GridView disabled")
	else
		settings.isBankGrid = true
		BankGridView_ToggleGrid(true)
		-- d("GridView enabled")
	end
end

local function ToggleGridOutlines()
	settings.allowRarityColor = not settings.allowRarityColor
	BankGridView_ToggleOutlines(settings.allowRarityColor)
end

local function BankGridViewLoaded(eventCode, addOnName)
    if(addOnName ~= "BankGridView") then
        return
    end

    defaults = {
    	isBankGrid = true,
    	isBankGrid = true,
    	isGuildBankGrid = true,
    	allowRarityColor = true
	}

    settings = ZO_SavedVars:New("BankGridView_Settings", 1, nil, defaults)

    ZO_PlayerBankBackpack.isGrid = settings.isBankGrid
    ZO_PlayerBankBackpack.showGridOutlines = settings.allowRarityColor

    SLASH_COMMANDS["/Bankgridview"] = function(args)
    	if(args == "outlines") then ToggleGridOutlines() end
	end
end

--initialize
function BankGridViewInitialized(self)
	InitGridView()

	local parentWindow = ZO_PlayerBank

	local button = WINDOW_MANAGER:CreateControl("ToggleBankGrid", parentWindow, CT_BUTTON)
	button:SetDimensions(100,20)
	button:SetAnchor(BOTTOMRIGHT, parentWindow, BOTTOMRIGHT, -200, 25)
	button:SetFont("ZoFontGameSmall")
	button:SetText("Toggle Grid View")
	button:SetHandler("OnClicked", ButtonClickHandler)
	button:SetMouseEnabled(true)

	EVENT_MANAGER:RegisterForEvent("BankGridViewLoaded", EVENT_ADD_ON_LOADED, BankGridViewLoaded)
end